#line 1 "C:/Users/Corey/Documents/Projects/C_Meter/PIC32/C_Meter_PIC32.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdbool.h"



 typedef char _Bool;
#line 5 "C:/Users/Corey/Documents/Projects/C_Meter/PIC32/C_Meter_PIC32.c"
sbit C_METER_RST at RC1_bit;
sbit C_METER_RST_DIR at TRISC1_bit;
sbit C_METER_INT at RE8_bit;
sbit C_METER_INT_DIR at TRISE8_bit;

void system_setup( void );
void setup_interrupt( void );
void InitTimer1( void );

char uart_text[ 40 ];
char final_text[ 40 ];
uint32_t int_count = 0;
uint32_t timer_count_end = 0;
 _Bool  sec_flag =  0 ;
float c_cal = 0.0;
float t_meas = 0.0;
float c_meas = 0.0;
float final = 0.0;
float t_cal = 0.0;


void main()
{

  _Bool  calibration_flag =  1 ;


 system_setup();
 setup_interrupt();
 InitTimer1();

 t_cal = 1.0 / 17776.0;
 c_cal = t_cal / 77616.0;

 int_count = 0;

 while(1)
 {

 if( sec_flag )
 {

 sprintf( uart_text, "Interrupts : %u\r\n", timer_count_end );
 UART2_Write_Text( uart_text );

 t_meas = 1.0 / timer_count_end;
 c_meas = t_meas / 77616.0;
 final = fabs( c_cal - c_meas );

 UART2_Write_Text( "Calibrated: " );
 FloatToStr( c_cal, uart_text );
 UART2_Write_Text( uart_text );
 UART2_Write_Text( "\r\n" );
 UART2_Write_Text( "Final: " );
 FloatToStr( final, final_text );
 UART2_Write_Text( final_text );
 UART2_Write_Text( "\r\n" );

 sec_flag =  0 ;
 int_count = 0;
 timer_count_end = 0;
 }
 }
}

void system_setup( void )
{

 C_METER_INT_DIR = 0;
 C_METER_RST_DIR = 1;


 C_METER_RST = 0;
 Delay_ms(50);
 C_METER_RST = 1;


 UART2_Init( 9600 );
 UART2_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{
 AD1PCFG = 0xFFFF;
 TRISE8_bit = 1;
 TRISB = 0;
 LATB = 0;

 LATB = 0x5555;

 INT1IP0_bit = 0;
 INT1IP1_bit = 0;
 INT1IP2_bit = 1;
 INT1IE_bit = 1;
 EnableInterrupts();
}

void int1_interrupt() iv IVT_EXTERNAL_1 ilevel 4 ics ICS_AUTO {
 int_count++;
 INT1IF_bit = 0;
}

void InitTimer1(){
 T1CON = 0x8030;
 T1IP0_bit = 1;
 T1IP1_bit = 1;
 T1IP2_bit = 1;
 T1IF_bit = 0;
 T1IE_bit = 1;
 PR1 = 62500;
 TMR1 = 0;
}
void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
 static count = 0;

 T1IF_bit = 0;

 count++;
 if( count >= 4 )
 {
 timer_count_end = int_count;
 int_count = 0;
 sec_flag =  1 ;
 count = 0;
 }
}
